--- ./openwebmail-send.pl	Thu May 27 15:58:42 2004
+++ ./openwebmail-send.pl	Fri Aug 13 21:14:11 2004
@@ -195,9 +195,9 @@
          $is_samecharset=1 if ( $attr[$_CONTENT_TYPE]=~/charset="?\Q$prefs{'charset'}\E"?/i);
 
          if ($is_samecharset) {
-            $s .= "Subject: ".ow::mime::encode_mimewords("$lang_text{'read'} - $attr[$_SUBJECT]",('Charset'=>$prefs{'charset'}))."\n";
+            $s .= "Subject: ".ow::mime::encode_mimewords_subject("$lang_text{'read'} - $attr[$_SUBJECT]",('Charset'=>$prefs{'charset'}))."\n";
          } else {
-            $s .= "Subject: ".ow::mime::encode_mimewords("Read - $attr[$_SUBJECT]", ('Charset'=>$prefs{'charset'}))."\n";
+            $s .= "Subject: ".ow::mime::encode_mimewords_subject("Read - $attr[$_SUBJECT]", ('Charset'=>$prefs{'charset'}))."\n";
          }
          $s .= "Date: $date\n".
                "Message-Id: $mymessageid\n".
@@ -1717,7 +1717,7 @@
 
    $s  = "";
    $s .= "Reply-To: ".ow::mime::encode_mimewords($replyto, ('Charset'=>$composecharset))."\n" if ($replyto);
-   $s .= "Subject: ".ow::mime::encode_mimewords($subject, ('Charset'=>$composecharset))."\n";
+   $s .= "Subject: ".ow::mime::encode_mimewords_subject($subject, ('Charset'=>$composecharset))."\n";
    $s .= "Date: $date\n";
    $s .= "Message-Id: $mymessageid\n";
    $s .= "In-Reply-To: $inreplyto\n" if ($inreplyto);
--- ./modules/mime.pl	Fri Nov 28 21:10:38 2003
+++ ./modules/mime.pl	Fri Aug 13 21:14:11 2004
@@ -102,6 +102,18 @@
     $rawstr;
 }
 
+sub encode_mimewords_subject {
+    my ($rawstr, %params) = @_;
+    my $charset  = $params{Charset} || 'ISO-8859-1';
+    #my $encoding = lc($params{Encoding} || 'q');
+    # q is used if there is english words in the string
+    my $encoding = lc($params{Encoding}) || (($rawstr=~/[A-Za-z]{4}/)? 'q':'b');
+
+    ($rawstr !~ /[$NONPRINT]/o)
+	 ? $rawstr                                        ### no unsafe chars
+	 : encode_mimeword($rawstr, $encoding, $charset);  ### has unsafe chars
+}
+
 # _decode_Q STRING
 #     Private: used by _decode_header() to decode "Q" encoding, which is
 #     almost, but not exactly, quoted-printable.  :-P
